' *********************************************************
' *-------------------------------------------------------*
' *- mignon game kit                                     -*
' *-                                                     -*
' *- Olaf Val 2003-2005                                  -*
' *- Supported by Martin Nawrath and Stefan Staedler     -*
' *-                                                     -*
' *- www.olafval.de/mignon                               -*
' *- (www.khm.de/~nawrath)                               -*
' *-------------------------------------------------------*
' *********************************************************

' BASCOM-AVR -> Optoins / Compiler / Chip / "M8" !

' Serial Communication: Baud = 9600

' Security and Configuration Bits:
' clock frequencies = 8 MHz internal.
' The MigPrg bootloader needs = Boot block of 512 words (BOOTRST enabled)


' Configurationen =============================================================
Dim F_s As Bit
Dim F_int As Bit
Dim Tics As Word
Dim Mx(5) As Byte
Dim Mxa(5) As Byte
Dim Mrow As Byte At &H100
Dim Mcol As Byte At &H101
Dim Midx As Byte At &H102
Config Timer0 = Timer , Prescale = 256
$crystal = 8000000
Osccal = 158                                      ' Set Internal Ocilator to 8MHz
On Timer0 Tm0isr
Enable Interrupts
Enable Timer0

'Dot-Matrix-LED Prots (5x7):
Config Pind.5 = Output                            ' R7
Config Pinb.2 = Output                            ' R6
Config Pinb.7 = Output                            ' R5
Config Pinb.1 = Output                            ' R4
Config Pinc.4 = Output                            ' R3
Config Pinc.0 = Output                            ' R2
Config Pinc.3 = Output                            ' R1

Config Pind.6 = Output                            ' C1
Config Pinc.1 = Output                            ' C2
Config Pinb.0 = Output                            ' C3
Config Pind.7 = Output                            ' C4
Config Pinc.2 = Output                            ' C5

Config Pinb.4 = Output                            ' loudspeaker

'Navigation Keys:
Config Pind.1 = Input                             'left
Config Pind.0 = Input                             'right
Set Portd.0
Set Portd.1
Config Pind.2 = Input                             'up
Config Pind.3 = Input                             'down
Set Portd.2
Set Portd.3

'Funktion Keys
Config Pinb.3 = Input                             'Function A
Config Pinc.5 = Input                             'Function B
Set Portb.3
Set Portc.5
' Configurationen Ende ========================================================

'IntroVariablen::
Dim Noise As Word
Dim Noise1 As Word
Dim Noise2 As Word
Dim Noisebit As Bit


'Intro +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' The variables Mx(1 - 5) contains the pit map of the dot-matrix-display.
' The prefix "&B" turn to the binary expression.
' Use the "1" to pant on the Display.

   Mx(1) = 0                                      'clear all
   Mx(2) = 0
   Mx(3) = 0
   Mx(4) = 0
   Mx(5) = 0

   Mx(1) = &B0001000                                 'paint a "+"
   Mx(2) = &B0001000
   Mx(3) = &B1111111
   Mx(4) = &B0001000
   Mx(5) = &B0001000

   Wait 4                                            'wait 4 sec

   Mx(1) = &B1000001                                 'paint a "X"
   Mx(2) = &B0110110
   Mx(3) = &B0001000
   Mx(4) = &B0110110
   Mx(5) = &B1000001

   Wait 4                                         'wait 4 sec

' Animation:

   Mx(1) = 0                                      'clear all
   Mx(2) = 0
   Mx(3) = 0
   Mx(4) = 0
   Mx(5) = 0

   Mx(1) = &B0001000                                 'Row 1 middle
   Wait 1
   Mx(1) = &B0000000                                 'clear row 1
   Mx(2) = &B0001000
   Wait 1
   Mx(2) = &B0000000
   Mx(3) = &B0001000
   Wait 1
   Mx(3) = &B0000000
   Mx(4) = &B0001000
   Wait 1

' Use the sound command to play sound:
   Sound Pinb.4 , 1000 , 100                         'Sound Duration, Tone Pitch
   Sound Pinb.4 , 5000 , 80                          'Sound Pulses , Periods
   'pulses  range from 1-65535
   'periods range from 1-65535

' Use sub programms to make sound experimentes:
   Gosub Makenois01                               'PSSSIIIOOOOOOOO
   Wait 1
   Gosub Makenois02                               'Rush
   Wait 2

   Mx(4) = &B0000000
'Intro Ende ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'Loop for the running Program code start (((((((((((((((((((((((((((((((((((((((
Do
' place you program code here!
Loop
'Loop of the rinning Program code ende )))))))))))))))))))))))))))))))))))))))))


Makenois01:
   For Noise = 1 To 6000
    If Rnd(3) = 1 Then
      Set Portb.4
    End If                                        'Rush
    If Rnd(3) = 1 Then
      Reset Portb.4
    End If
   Next
 Return

 Makenois02:                                      'PSSSIIIOOOOOOOO
   For Noise = 1 To 90000
   Noise1 = Noise1 + 1
    If Noise1 > Noise2 Then
      Noise1 = 0
      Noise2 = Noise2 + 1
      If Noisebit = 1 Then
       Noisebit = 0
       Set Portb.4
      Else
       Noisebit = 1
       Reset Portb.4
      End If
    End If
   Next
 Return


' machine-code for the LED-Dot-Matrix start*************************************
' machine-code start +++********************************************************
Wait_us:
Wait_us_50_1:
      nop
      nop
      dec      r18
      brne     Wait_us_50_1
      ret
$end Asm
' Timer0 Interrupt Service Routine  2ms
Tm0isr:                                           ' Prescaler 8MHz/256 / 63 8 MHz
Set F_int                                         ' Interrupt Flag
Timer0 = 193                                      ' 256-63= 193 = 2 ms
Incr Tics
$asm
   cbi      Portd,5                               ' clear all 7 Row Pins
   cbi      Portb,2
   cbi      Portb,7
   cbi      Portb,1
   cbi      Portc,4
   cbi      Portc,0
   cbi      Portc,3
   cbi      Portd,6                               ' clear all 5 Column Pins
   cbi      Portc,1
   cbi      Portb,0
   cbi      Portd,7
   cbi      Portc,2
$end Asm
 If Mcol = 32 Then
      Mcol = 1
      Midx = 0
   End If
   Incr Midx
   If Mcol = 0 Then Mcol = 1
   Shift Mcol , Left , 1
$asm
   lds      r16,{mcol}                            ' Transistors at Port D6,C1,B0,D7,C2
Cc1:
   sbrs     r16,1
   rjmp     cc2
   sbi      portd,6
Cc2:
   sbrs     r16,2
   rjmp     cc3
   sbi      portc,1
Cc3:
   sbrs     r16,3
   rjmp     cc4
   sbi      portb,0
Cc4:
   sbrs     r16,4
   rjmp     cc5
   sbi      portd,7
Cc5:
   sbrs     r16,5
   rjmp     ccx
   sbi      portc,2
Ccx:
$end Asm
   Mrow = Mx(midx)
$asm
   lds      r16,{Mrow}                            ' 7 Row-Pins on like Bit Pattern
Rr1:
   sbrs     r16,0                                 ' in Variable Mrow
   rjmp     rr2
   sbi      portd,5
Rr2:
   sbrs     r16,1
   rjmp     rr3
   sbi      portb,2
Rr3:
   sbrs     r16,2
   rjmp     rr4
   sbi      portb,7
Rr4:
   sbrs     r16,3
   rjmp     rr5
   sbi      portb,1
Rr5:
   sbrs     r16,4
   rjmp     rr6
   sbi      portc,4
Rr6:
   sbrs     r16,5
   rjmp     rr7
   sbi      portc,0
Rr7:
   sbrs     r16,6
   rjmp     rrx
   sbi      portc,3
Rrx:
$end Asm
Return
' machine-code End +++++********************************************************
' machine-code for the LED-Dot-Matrix End **************************************