' *********************************************************
' *-------------------------------------------------------*
' *- mignon game kit                                     -*
' *-                                                     -*
' *- Olaf Val 2003-2005                                  -*
' *- Supported by Martin Nawrath and Stefan Staedler     -*
' *-                                                     -*
' *- www.olafval.de/mignon                               -*
' *- (www.khm.de/~nawrath)                               -*
' *-------------------------------------------------------*
' *********************************************************

' BASCOM-AVR -> Optoins / Compiler / Chip / "M8" !

' Serial Communication: Baud = 9600

' Security and Configuration Bits:
' clock frequencies = 8 MHz internal.
' The MigPrg bootloader needs = Boot block of 512 words (BOOTRST enabled)

' Configurationen =============================================================
Dim F_s As Bit
Dim F_int As Bit
Dim Tics As Word
Dim Mx(5) As Byte
Dim Mxa(5) As Byte
Dim Mrow As Byte At &H100
Dim Mcol As Byte At &H101
Dim Midx As Byte At &H102
Config Timer0 = Timer , Prescale = 256
$crystal = 8000000
Osccal = 158                                      ' Set Internal Ocilator to 8MHz
On Timer0 Tm0isr
Enable Interrupts
Enable Timer0

'Dot-Matrix-LED Prots (5x7):
Config Pind.5 = Output                            ' R7
Config Pinb.2 = Output                            ' R6
Config Pinb.7 = Output                            ' R5
Config Pinb.1 = Output                            ' R4
Config Pinc.4 = Output                            ' R3
Config Pinc.0 = Output                            ' R2
Config Pinc.3 = Output                            ' R1

Config Pind.6 = Output                            ' C1
Config Pinc.1 = Output                            ' C2
Config Pinb.0 = Output                            ' C3
Config Pind.7 = Output                            ' C4
Config Pinc.2 = Output                            ' C5

Config Pinb.4 = Output                            ' loudspeaker

'Navigation Keys:
Config Pind.1 = Input                             'left
Config Pind.0 = Input                             'right
Set Portd.0
Set Portd.1
Config Pind.2 = Input                             'up
Config Pind.3 = Input                             'down
Set Portd.2
Set Portd.3

' Funktion Keys:
Config Pinb.3 = Input                             'Funktion A
Config Pinc.5 = Input                             'Funktion B
Set Portb.3
Set Portc.5
Declare Sub Geschaft
' Configurationen Ende ========================================================



'Intro +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   Mx(1) = 0                                      'clear all
   Mx(2) = 0
   Mx(3) = 0
   Mx(4) = 0
   Mx(5) = 0

Wait 1                                            'wait 1 sec
Mx(1) = &B0001000                                 'Row
Wait 1
Mx(1) = &B0000000                                 'clear row 1
Mx(2) = &B0001000
Wait 1
Mx(2) = &B0000000
Mx(3) = &B0001000
Wait 1
Mx(3) = &B0000000
Mx(4) = &B0001000
Wait 1
Sound Pinb.4 , 1000 , 100                         'Sound Pulses , Periods
Sound Pinb.4 , 5000 , 80
Wait 2
Mx(4) = &B0000000
'Intro Ende ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'Game Variablen:::
Dim Tick As Word
Dim Press1 As Bit
Dim Press2 As Bit
Dim Press3 As Bit
Dim Press4 As Bit
Dim Press5 As Bit
Dim Press6 As Bit
Dim Bb1 As Byte
Dim R As Byte
Dim L As Byte
Dim X As Byte
Dim Y As Byte


'Watre Schleife ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Do
 'Navigation -----------------------------
   Tick = Tick + 1
  If Tick > 1000 Then                             '1000 clock(
   Tick = 0

   Mxa(1) = 0                                     'clear all
   Mxa(2) = 0
   Mxa(3) = 0
   Mxa(4) = 0
   Mxa(5) = 0


    ' Spielfigur:----------
    If Pind.1 = 0 Then                            'Incoming key code
     If Press1 = 0 Then
      X = X - 1                                   'go left
     End If
     Press1 = 1
     Else
     Press1 = 0
    End If

    If Pind.0 = 0 Then
     If Press2 = 0 Then
      X = X + 1                                   'go right
     End If
     Press2 = 1
    Else
     Press2 = 0
    End If

    If Pind.3 = 0 Then
     If Press3 = 0 Then
      Y = Y + 1                                   'go down
     End If
     Press3 = 1
    Else
     Press3 = 0
    End If

    If Pind.2 = 0 Then
     If Press4 = 0 Then
      Y = Y - 1                                   'go up
     End If
     Press4 = 1
    Else
     Press4 = 0
    End If

    If X > 7 Then                                 'Border
      X = 7
    End If
    If X < 1 Then
      X = 1
    End If
    If Y > 5 Then
      Y = 5
    End If
    If Y < 1 Then
      Y = 1
    End If

  Gosub Showpoints                                'use this sub programm to set a point
  End If                                          '1000 clock)
'Navigation ende -----------------------
Loop
'Warte Schleife Ende +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Showpoints:
' Sets a Point with x and y positions
' by adding them to the Mx(1-5) variables (= dot-matrix-displays bit map)
    Bb1 = &B10000000
    R = 8 - X
    For L = 1 To R
     Rotate Bb1 , Left , 1
    Next
    Mxa(y) = Mxa(y) Or Bb1

    For L = 1 To 5
        Mx(l) = Mxa(l)
    Next

' If you want to have more then one point, you need to use more games variables
' dim x1 as Byte
' dim y1 as Byte
' dim x2 as Byte
' 

' Too many game points will cause a jitter effect. In this case it is better
' to set the points into Mxa(1-5) and to copy Mxa(1-5) into Mx(1-5) in one step.

Return


' machine-code for the LED-Dot-Matrix start*************************************
' machine-code start +++********************************************************
Wait_us:
Wait_us_50_1:
      nop
      nop
      dec      r18
      brne     Wait_us_50_1
      ret
$end Asm
' Timer0 Interrupt Service Routine  2ms
Tm0isr:                                           ' Prescaler 8MHz/256 / 63 8 MHz
Set F_int                                         ' Interrupt Flag
Timer0 = 193                                      ' 256-63= 193 = 2 ms
Incr Tics
$asm
   cbi      Portd,5                               ' clear all 5 Row Pins
   cbi      Portb,2
   cbi      Portb,7
   cbi      Portb,1
   cbi      Portc,4
   cbi      Portc,0
   cbi      Portc,3
   cbi      Portd,6                               ' clear all 5 Column Pins
   cbi      Portc,1
   cbi      Portb,0
   cbi      Portd,7
   cbi      Portc,2
$end Asm
 If Mcol = 32 Then
      Mcol = 1
      Midx = 0
   End If
   Incr Midx
   If Mcol = 0 Then Mcol = 1
   Shift Mcol , Left , 1
$asm
   lds      r16,{mcol}                            ' Transistoren an Ports D6,C1,B0,D7,C2
Cc1:
   sbrs     r16,1
   rjmp     cc2
   sbi      portd,6
Cc2:
   sbrs     r16,2
   rjmp     cc3
   sbi      portc,1
Cc3:
   sbrs     r16,3
   rjmp     cc4
   sbi      portb,0
Cc4:
   sbrs     r16,4
   rjmp     cc5
   sbi      portd,7
Cc5:
   sbrs     r16,5
   rjmp     ccx
   sbi      portc,2
Ccx:
$end Asm
   Mrow = Mx(midx)
$asm
   lds      r16,{Mrow}                            ' 7 Row-Pins on like Bit Pattern
Rr1:
   sbrs     r16,0                                 ' in Variable Mrow
   rjmp     rr2
   sbi      portd,5
Rr2:
   sbrs     r16,1
   rjmp     rr3
   sbi      portb,2
Rr3:
   sbrs     r16,2
   rjmp     rr4
   sbi      portb,7
Rr4:
   sbrs     r16,3
   rjmp     rr5
   sbi      portb,1
Rr5:
   sbrs     r16,4
   rjmp     rr6
   sbi      portc,4
Rr6:
   sbrs     r16,5
   rjmp     rr7
   sbi      portc,0
Rr7:
   sbrs     r16,6
   rjmp     rrx
   sbi      portc,3
Rrx:
$end Asm
Return
' machine-code End +++++********************************************************
' machine-code for the LED-Dot-Matrix End **************************************